package com.gyee.table.controller;

import com.alibaba.fastjson2.JSONObject;
import com.gyee.table.entity.TableColumnHeader;
import com.gyee.table.result.Result;
import com.gyee.table.result.ResultCode;
import com.gyee.table.service.IObjectService;
import com.gyee.table.service.ITableColumnHeaderService;
import com.gyee.table.service.ITableHeaderColumnService;
import com.gyee.table.service.ITableHeaderService;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.script.ScriptException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author gfhd
 * @since 2023-01-11
 */
@Slf4j
@RestController
@RequestMapping("/table")
public class TableHeaderController {

    @Resource
    private ITableHeaderService tableHeaderService;
    @Resource
    private ITableHeaderColumnService tableHeaderColumnService;
    @Resource
    private ITableColumnHeaderService tableColumnHeaderService;
    @Resource
    private IObjectService objectService;

    private final static String regex = "#|/\\*|\\*/|--|\\buse\\b|\\binsert\\b|\\bdelete\\b|\\bupdate\\b|\\bcreate\\b|\\bdrop\\b|\\btruncate\\b|\\balter\\b|\\bgrant\\b|\\bexecute\\b|\\bexec\\b|\\bxp_cmdshell\\b|\\bcall\\b|\\bdeclare\\b|\\bsource\\b|\\bsql\\b|\\bchr\\b|\\bmid\\b|\\bmaster\\b|\\bchar\\b|\\bsitename\\b|\\bnet user\\b|;|-|\\+|,|\\btable\\b|\\bgroup_concat\\b|\\bcolumn_name\\b|\\binformation_schema.columns\\b|\\btable_schema\\b|//|/";

    @GetMapping("/header/{headername}")
    private JSONObject header(@PathVariable String headername){
        if(StringUtils.isBlank(headername)) return Result.error(ResultCode.PARAM_IS_BLANK);
        //List<TableHeaderColumn> header = tableHeaderService.getHeader(headername);
        List<TableColumnHeader> header = tableColumnHeaderService.getHeader(headername);
        /*Map<String, Object> map = new HashMap<>();
        map.put("name", headername);
        List<TableColumnHeader> header = tableColumnHeaderService.listByMap(map);*/
        tableColumnHeaderService.saveBatch(header);
        //tableHeaderColumnService.saveBatch(header);
        return Result.successData(ResultCode.SUCCESS,header);
    }
    @PostMapping("/data")
    private JSONObject getData(@RequestBody Map map) throws ScriptException {
        return objectService.selectBySql(map);
    }

    @PutMapping("/header/update")
    private JSONObject updateTable(@RequestBody List<TableColumnHeader> tableHeader){
        boolean b = tableColumnHeaderService.updateBatchById(tableHeader);
        if(b){
            return Result.success();
        }else {
            return Result.error();
        }
    }

    @GetMapping("/test")
    private JSONObject test(){
        //List<TableHeaderColumn> list = tableHeaderColumnService.list();
        return Result.successData(ResultCode.SUCCESS,null);
    }
}
